package checksum

import (
	"hash"
	"hash/adler32"
)

type (
	Adler32 struct {
		d hash.Hash
	}
)

func (m *Adler32) String() string {
	return "adler32"
}

func (m *Adler32) Append(data []byte) {
	if m.d == nil {
		m.d = adler32.New()
	}

	m.d.Write(data)
}

func (m *Adler32) Finish() []byte {
	if m.d == nil {
		m.d = adler32.New()
	}

	return m.d.Sum(nil)
}
