package checksum

import (
	"crypto/md5"
	"hash"
)

type (
	Md5 struct {
		d hash.Hash
	}
)

func (m *Md5) String() string {
	return "md5"
}

func (m *Md5) Append(data []byte) {
	if m.d == nil {
		m.d = md5.New()
	}

	m.d.Write(data)
}

func (m *Md5) Finish() []byte {
	if m.d == nil {
		m.d = md5.New()
	}

	return m.d.Sum(nil)
}
